Bug 812506 - BCM4313 wifi speed terribly slow
BCM4313 wifi speed terribly slow
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
17
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: John W. Linville
Fedora Extras Quality Assurance
Wireless Broadcom
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-04-14 02:30 EDT by Ankur Sinha (FranciscoD)
Modified: 2013-01-06 14:59 EST (History)
10 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2013-01-02 08:15:00 EST
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
dmesg output (87.83 KB, text/plain)
2012-04-14 02:30 EDT, Ankur Sinha (FranciscoD)
no flags Details

  None (edit)
Description Ankur Sinha (FranciscoD) 2012-04-14 02:30:10 EDT
Created attachment 577444 [details]
dmesg output

It's awesome that my wifi card works out of the box. Till fedora 16, I needed to install the kmods from RPMFusion.

[root@ankur ~]# lspci | egrep -i network
12:00.0 Network controller: Broadcom Corporation BCM4313 802.11b/g/n Wireless LAN Controller (rev 01)
[root@ankur ~]#

However, wireless is very slow. I'm sitting right next to my router. Byobu shows the wireless strenght as 100% too. While on LAN, I get the full 2mbps speed, on wifi I get only around 200kbps. There seem to be quite a few errors related to ieee80211 in dmesg too (attached). 

I'd like to help resolving this issue. Please let me know if you need any additional info.

Thanks,
Ankur
Comment 1 Ankur Sinha (FranciscoD) 2012-04-15 04:50:46 EDT
Someone suggested I try to switch off power saving on the device:

[root@ankur ~]# iwconfig wlan0 power off
Error for wireless request "Set Power Management" (8B2C) :
    SET failed on device wlan0 ; Operation not supported.
[root@ankur ~]#

I tried to use powertop too, but cannot do it. Is powersaving mode the reason behind the slow speeds?

Thanks,
Ankur
Comment 2 Arend van Spriel 2012-04-17 06:06:44 EDT
As the error message is showing you powersaving is not available. powersaving is not the problem here.

I do see indeed a lot of these messages:
[   75.536457] ieee80211 phy0: brcms_c_prec_enq_head: No where to go, prec == 4

This indicates that the transmit queues in the driver have reached their limit. I noticed that you are using regulatory domain IN (India?). Could you tell me what channel your AP is on?
Comment 3 Ankur Sinha (FranciscoD) 2012-04-17 08:49:32 EDT
(In reply to comment #2)
> As the error message is showing you powersaving is not available. powersaving
> is not the problem here.
> 
> I do see indeed a lot of these messages:
> [   75.536457] ieee80211 phy0: brcms_c_prec_enq_head: No where to go, prec == 4
> 
> This indicates that the transmit queues in the driver have reached their limit.
> I noticed that you are using regulatory domain IN (India?). Could you tell me
> what channel your AP is on?

Uhm, I'm not that advanced a user. Can you please tell me what commands you want me to run? I'll get back to you with the outputs.

Yes. I am in India. I was using the kmod packages that rpmfusion provides for Fedora 16 and this issue didn't crop up. They package up the linux sta driver:

[root@ankur ~]# repoquery -i kmod-wl

Name        : kmod-wl
Version     : 5.100.82.112
Release     : 2.fc17.2
Architecture: x86_64
Size        : 0
Packager    : <http://nonfree.rpmfusion.org/>
Group       : System Environment/Kernel
URL         : http://www.broadcom.com/support/802.11/linux_sta.php
Repository  : rpmfusion-nonfree-updates-testing
Summary     : Metapackage which tracks in wl kernel module for newest kernel
Source      : wl-kmod-5.100.82.112-2.fc17.2.src.rpm
Description :
This is a meta-package without payload which sole purpose is to require the
wl kernel module(s) for the newest kernel.
to make sure you get it together with a new kernel.
[root@ankur ~]#

Thanks,
Ankur
Comment 4 Ankur Sinha (FranciscoD) 2012-04-19 01:04:37 EDT
(In reply to comment #2)
> As the error message is showing you powersaving is not available. powersaving
> is not the problem here.
> 
> I do see indeed a lot of these messages:
> [   75.536457] ieee80211 phy0: brcms_c_prec_enq_head: No where to go, prec == 4
> 
> This indicates that the transmit queues in the driver have reached their limit.
> I noticed that you are using regulatory domain IN (India?). Could you tell me
> what channel your AP is on?

Hello,

Is this what you were asking for?

[root@ankur ~]# iwlist wlan0 freq
wlan0     13 channels in total; available frequencies :
          Channel 01 : 2.412 GHz
          Channel 02 : 2.417 GHz
          Channel 03 : 2.422 GHz
          Channel 04 : 2.427 GHz
          Channel 05 : 2.432 GHz
          Channel 06 : 2.437 GHz
          Channel 07 : 2.442 GHz
          Channel 08 : 2.447 GHz
          Channel 09 : 2.452 GHz
          Channel 10 : 2.457 GHz
          Channel 11 : 2.462 GHz
          Channel 12 : 2.467 GHz
          Channel 13 : 2.472 GHz
          Current Frequency:2.437 GHz (Channel 6)

[root@ankur ~]#


Thanks,
Ankur
Comment 5 Patrick Boutilier 2012-04-22 15:37:33 EDT
(In reply to comment #0)
> Created attachment 577444 [details]
> dmesg output
> 
> It's awesome that my wifi card works out of the box. Till fedora 16, I needed
> to install the kmods from RPMFusion.
<snip>

Are you sure you are not still using the package from rpmfusion? I don't see any wl drivers unless I install akmod-wl from rpmfusion.

Was this a clean install or an upgrade over top of a Fedora 16 install?
Comment 6 Ankur Sinha (FranciscoD) 2012-04-23 00:23:38 EDT
(In reply to comment #5)
> (In reply to comment #0)
> > Created attachment 577444 [details]
> > dmesg output
> > 
> > It's awesome that my wifi card works out of the box. Till fedora 16, I needed
> > to install the kmods from RPMFusion.
> <snip>
> 
> Are you sure you are not still using the package from rpmfusion? I don't see
> any wl drivers unless I install akmod-wl from rpmfusion.

Yes. I am. :)

> 
> Was this a clean install or an upgrade over top of a Fedora 16 install?

Clean F17 install.

[root@ankur ~]# rpm -qa | egrep kmod
kmod-7-1.fc17.x86_64
libmikmod-3.2.0-13.beta2.fc17.x86_64
kmod-libs-7-1.fc17.x86_64
[root@ankur ~]#


Ankur
Comment 7 Arend van Spriel 2012-04-23 04:29:02 EDT
Ankur

You are not using the wl driver for your wireless. The log I looked at shows that brcmsmac is used. The information you sent me shows channels 1 to 13 are available. I assume your AP is on channel 6. You can confirm by calling iwconfig when the link is up.
Comment 8 Ankur Sinha (FranciscoD) 2012-04-23 04:37:27 EDT
(In reply to comment #7)
> Ankur
> 
> You are not using the wl driver for your wireless. The log I looked at shows
> that brcmsmac is used. The information you sent me shows channels 1 to 13 are
> available. I assume your AP is on channel 6. You can confirm by calling
> iwconfig when the link is up.

Hi Arend,

With the latest kernel update, wireless doesn't work anymore. I've filed a separate bug for the issue:

https://bugzilla.redhat.com/show_bug.cgi?id=815059

I'm unsure of what's happening. Are there multiple drivers supporting my wireless hardware, since it worked initially?

I'll boot into the older kernel (where wireless worked) and give you the output of iwconfig once I get back to my system in the evening.


Thanks,
Ankur
Comment 9 Arend van Spriel 2012-04-23 08:15:14 EDT
Could you also run following command ´lspci -v' on both kernels?
Comment 10 Patrick Boutilier 2012-04-23 08:36:35 EDT
Ah. My wireless does work with brcmsmac as well. Works with
kernel-3.3.2-8.fc17.x86_64 as well. The only thing I have to do is disable then
re-enable wireless in NetworkManager for wlan0 to show up. I think this is a
NwtworkManager bug because iwconfig shows wlan0 when NetworkManager is not
seeing it.
Comment 11 Ankur Sinha (FranciscoD) 2012-04-23 09:01:34 EDT
(In reply to comment #10)
> Ah. My wireless does work with brcmsmac as well. Works with
> kernel-3.3.2-8.fc17.x86_64 as well. The only thing I have to do is disable then
> re-enable wireless in NetworkManager for wlan0 to show up. I think this is a
> NwtworkManager bug because iwconfig shows wlan0 when NetworkManager is not
> seeing it.

Restarting NetworkManager got wireless up for me too. I've closed the other bug. Requested outputs:

[root@ankur ~]# iwconfig wlan0
wlan0     IEEE 802.11bgn  ESSID:"billabong"
          Mode:Managed  Frequency:2.437 GHz  Access Point: C0:3F:0E:10:B5:5A
          Bit Rate=54 Mb/s   Tx-Power=19 dBm
          Retry  long limit:7   RTS thr:off   Fragment thr:off
          Encryption key:off
          Power Management:off
          Link Quality=70/70  Signal level=-19 dBm
          Rx invalid nwid:0  Rx invalid crypt:0  Rx invalid frag:0
          Tx excessive retries:1215  Invalid misc:5772   Missed beacon:0

[root@ankur ~]# uname -a
Linux ankur.pc 3.3.2-8.fc17.x86_64 #1 SMP Sat Apr 21 12:44:25 UTC 2012 x86_64 x86_64 x86_64 GNU/Linux


[root@ankur ~]# lspci -v

00:00.0 Host bridge: Intel Corporation Core Processor DRAM Controller (rev 18)
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0
	Capabilities: [e0] Vendor Specific Information: Len=0c <?>

00:01.0 PCI bridge: Intel Corporation Core Processor PCI Express x16 Root Port (rev 18) (prog-if 00 [Normal decode])
	Flags: bus master, fast devsel, latency 0
	Bus: primary=00, secondary=01, subordinate=01, sec-latency=0
	I/O behind bridge: 0000e000-0000efff
	Memory behind bridge: fa000000-fb0fffff
	Prefetchable memory behind bridge: 00000000c0000000-00000000d1ffffff
	Capabilities: [88] Subsystem: Dell Device 0440
	Capabilities: [80] Power Management version 3
	Capabilities: [90] MSI: Enable+ Count=1/1 Maskable- 64bit-
	Capabilities: [a0] Express Root Port (Slot+), MSI 00
	Capabilities: [100] Virtual Channel
	Kernel driver in use: pcieport

00:16.0 Communication controller: Intel Corporation 5 Series/3400 Series Chipset HECI Controller (rev 06)
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0, IRQ 11
	Memory at fbe09000 (64-bit, non-prefetchable) [size=16]
	Capabilities: [50] Power Management version 3
	Capabilities: [8c] MSI: Enable- Count=1/1 Maskable- 64bit+

00:1a.0 USB Controller: Intel Corporation 5 Series/3400 Series Chipset USB2 Enhanced Host Controller (rev 06) (prog-if 20 [EHCI])
	Subsystem: Dell Device 0440
	Flags: bus master, medium devsel, latency 0, IRQ 16
	Memory at fbe08000 (32-bit, non-prefetchable) [size=1K]
	Capabilities: [50] Power Management version 2
	Capabilities: [58] Debug port: BAR=1 offset=00a0
	Capabilities: [98] PCI Advanced Features
	Kernel driver in use: ehci_hcd

00:1b.0 Audio device: Intel Corporation 5 Series/3400 Series Chipset High Definition Audio (rev 06)
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0, IRQ 47
	Memory at fbe00000 (64-bit, non-prefetchable) [size=16K]
	Capabilities: [50] Power Management version 2
	Capabilities: [60] MSI: Enable+ Count=1/1 Maskable- 64bit+
	Capabilities: [70] Express Root Complex Integrated Endpoint, MSI 00
	Capabilities: [100] Virtual Channel
	Capabilities: [130] Root Complex Link
	Kernel driver in use: snd_hda_intel

00:1c.0 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 1 (rev 06) (prog-if 00 [Normal decode])
	Flags: bus master, fast devsel, latency 0
	Bus: primary=00, secondary=11, subordinate=11, sec-latency=0
	I/O behind bridge: 00003000-00003fff
	Memory behind bridge: d2f00000-d30fffff
	Prefetchable memory behind bridge: 00000000d3100000-00000000d32fffff
	Capabilities: [40] Express Root Port (Slot+), MSI 00
	Capabilities: [80] MSI: Enable+ Count=1/1 Maskable- 64bit-
	Capabilities: [90] Subsystem: Dell Device 0440
	Capabilities: [a0] Power Management version 2
	Kernel driver in use: pcieport

00:1c.1 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 2 (rev 06) (prog-if 00 [Normal decode])
	Flags: bus master, fast devsel, latency 0
	Bus: primary=00, secondary=12, subordinate=12, sec-latency=0
	I/O behind bridge: 00002000-00002fff
	Memory behind bridge: fbd00000-fbdfffff
	Prefetchable memory behind bridge: 00000000d2d00000-00000000d2efffff
	Capabilities: [40] Express Root Port (Slot+), MSI 00
	Capabilities: [80] MSI: Enable+ Count=1/1 Maskable- 64bit-
	Capabilities: [90] Subsystem: Dell Device 0440
	Capabilities: [a0] Power Management version 2
	Kernel driver in use: pcieport

00:1c.2 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 3 (rev 06) (prog-if 00 [Normal decode])
	Flags: bus master, fast devsel, latency 0
	Bus: primary=00, secondary=13, subordinate=13, sec-latency=0
	I/O behind bridge: 0000d000-0000dfff
	Memory behind bridge: fbc00000-fbcfffff
	Prefetchable memory behind bridge: 00000000d2c00000-00000000d2cfffff
	Capabilities: [40] Express Root Port (Slot+), MSI 00
	Capabilities: [80] MSI: Enable+ Count=1/1 Maskable- 64bit-
	Capabilities: [90] Subsystem: Dell Device 0440
	Capabilities: [a0] Power Management version 2
	Kernel driver in use: pcieport

00:1c.4 PCI bridge: Intel Corporation 5 Series/3400 Series Chipset PCI Express Root Port 5 (rev 06) (prog-if 00 [Normal decode])
	Flags: bus master, fast devsel, latency 0
	Bus: primary=00, secondary=15, subordinate=15, sec-latency=0
	I/O behind bridge: 0000c000-0000cfff
	Memory behind bridge: fb200000-fbbfffff
	Prefetchable memory behind bridge: 00000000d2100000-00000000d2afffff
	Capabilities: [40] Express Root Port (Slot+), MSI 00
	Capabilities: [80] MSI: Enable+ Count=1/1 Maskable- 64bit-
	Capabilities: [90] Subsystem: Dell Device 0440
	Capabilities: [a0] Power Management version 2
	Kernel driver in use: pcieport

00:1d.0 USB Controller: Intel Corporation 5 Series/3400 Series Chipset USB2 Enhanced Host Controller (rev 06) (prog-if 20 [EHCI])
	Subsystem: Dell Device 0440
	Flags: bus master, medium devsel, latency 0, IRQ 23
	Memory at fbe07000 (32-bit, non-prefetchable) [size=1K]
	Capabilities: [50] Power Management version 2
	Capabilities: [58] Debug port: BAR=1 offset=00a0
	Capabilities: [98] PCI Advanced Features
	Kernel driver in use: ehci_hcd

00:1e.0 PCI bridge: Intel Corporation 82801 Mobile PCI Bridge (rev a6) (prog-if 01 [Subtractive decode])
	Flags: bus master, fast devsel, latency 0
	Bus: primary=00, secondary=20, subordinate=20, sec-latency=32
	Capabilities: [50] Subsystem: Dell Device 0440

00:1f.0 ISA bridge: Intel Corporation Mobile 5 Series Chipset LPC Interface Controller (rev 06)
	Subsystem: Dell Device 0440
	Flags: bus master, medium devsel, latency 0
	Capabilities: [e0] Vendor Specific Information: Len=10 <?>

00:1f.2 SATA controller: Intel Corporation 5 Series/3400 Series Chipset 6 port SATA AHCI Controller (rev 06) (prog-if 01 [AHCI 1.0])
	Subsystem: Dell Device 0440
	Flags: bus master, 66MHz, medium devsel, latency 0, IRQ 45
	I/O ports at f070 [size=8]
	I/O ports at f060 [size=4]
	I/O ports at f050 [size=8]
	I/O ports at f040 [size=4]
	I/O ports at f020 [size=32]
	Memory at fbe06000 (32-bit, non-prefetchable) [size=2K]
	Capabilities: [80] MSI: Enable+ Count=1/1 Maskable- 64bit-
	Capabilities: [70] Power Management version 3
	Capabilities: [a8] SATA HBA v1.0
	Capabilities: [b0] PCI Advanced Features
	Kernel driver in use: ahci

00:1f.3 SMBus: Intel Corporation 5 Series/3400 Series Chipset SMBus Controller (rev 06)
	Subsystem: Dell Device 0440
	Flags: medium devsel, IRQ 18
	Memory at fbe05000 (64-bit, non-prefetchable) [size=256]
	I/O ports at f000 [size=32]

00:1f.6 Signal processing controller: Intel Corporation 5 Series/3400 Series Chipset Thermal Subsystem (rev 06)
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0, IRQ 18
	Memory at fbe04000 (64-bit, non-prefetchable) [size=4K]
	Capabilities: [50] Power Management version 3
	Capabilities: [80] MSI: Enable- Count=1/1 Maskable- 64bit-
	Kernel driver in use: intel ips

01:00.0 VGA compatible controller: nVidia Corporation GT218 [GeForce 310M] (rev a2) (prog-if 00 [VGA controller])
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0, IRQ 16
	Memory at fa000000 (32-bit, non-prefetchable) [size=16M]
	Memory at c0000000 (64-bit, prefetchable) [size=256M]
	Memory at d0000000 (64-bit, prefetchable) [size=32M]
	I/O ports at e000 [size=128]
	Expansion ROM at fb000000 [disabled] [size=512K]
	Capabilities: [60] Power Management version 3
	Capabilities: [68] MSI: Enable- Count=1/1 Maskable- 64bit+
	Capabilities: [78] Express Endpoint, MSI 00
	Capabilities: [b4] Vendor Specific Information: Len=14 <?>
	Capabilities: [100] Virtual Channel
	Capabilities: [128] Power Budgeting <?>
	Capabilities: [600] Vendor Specific Information: ID=0001 Rev=1 Len=024 <?>
	Kernel driver in use: nouveau

01:00.1 Audio device: nVidia Corporation High Definition Audio Controller (rev a1)
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0, IRQ 16
	Memory at fb080000 (32-bit, non-prefetchable) [size=16K]
	Capabilities: [60] Power Management version 3
	Capabilities: [68] MSI: Enable- Count=1/1 Maskable- 64bit+
	Capabilities: [78] Express Endpoint, MSI 00
	Kernel driver in use: snd_hda_intel

12:00.0 Network controller: Broadcom Corporation BCM4313 802.11b/g/n Wireless LAN Controller (rev 01)
	Subsystem: Dell XPS 8300
	Flags: bus master, fast devsel, latency 0, IRQ 17
	Memory at fbd00000 (64-bit, non-prefetchable) [size=16K]
	Capabilities: [40] Power Management version 3
	Capabilities: [58] Vendor Specific Information: Len=78 <?>
	Capabilities: [48] MSI: Enable- Count=1/1 Maskable- 64bit+
	Capabilities: [d0] Express Endpoint, MSI 00
	Capabilities: [100] Advanced Error Reporting
	Capabilities: [13c] Virtual Channel
	Capabilities: [160] Device Serial Number 00-00-38-ff-ff-88-c0-cb
	Capabilities: [16c] Power Budgeting <?>
	Kernel driver in use: bcma-pci-bridge

13:00.0 Ethernet controller: Realtek Semiconductor Co., Ltd. RTL8111/8168B PCI Express Gigabit Ethernet controller (rev 03)
	Subsystem: Dell Device 0440
	Flags: bus master, fast devsel, latency 0, IRQ 46
	I/O ports at d000 [size=256]
	Memory at d2c04000 (64-bit, prefetchable) [size=4K]
	Memory at d2c00000 (64-bit, prefetchable) [size=16K]
	Expansion ROM at fbc00000 [disabled] [size=128K]
	Capabilities: [40] Power Management version 3
	Capabilities: [50] MSI: Enable+ Count=1/1 Maskable- 64bit+
	Capabilities: [70] Express Endpoint, MSI 01
	Capabilities: [ac] MSI-X: Enable- Count=4 Masked-
	Capabilities: [cc] Vital Product Data
	Capabilities: [100] Advanced Error Reporting
	Capabilities: [140] Virtual Channel
	Capabilities: [160] Device Serial Number 03-00-00-00-68-4c-e0-00
	Kernel driver in use: r8169

ff:00.0 Host bridge: Intel Corporation Core Processor QuickPath Architecture Generic Non-core Registers (rev 05)
	Subsystem: Intel Corporation Device 8086
	Flags: bus master, fast devsel, latency 0

ff:00.1 Host bridge: Intel Corporation Core Processor QuickPath Architecture System Address Decoder (rev 05)
	Subsystem: Intel Corporation Device 8086
	Flags: bus master, fast devsel, latency 0

ff:02.0 Host bridge: Intel Corporation Core Processor QPI Link 0 (rev 05)
	Subsystem: Intel Corporation Device 8086
	Flags: bus master, fast devsel, latency 0

ff:02.1 Host bridge: Intel Corporation Core Processor QPI Physical 0 (rev 05)
	Subsystem: Intel Corporation Device 8086
	Flags: bus master, fast devsel, latency 0

ff:02.2 Host bridge: Intel Corporation Core Processor Reserved (rev 05)
	Subsystem: Intel Corporation Device 8086
	Flags: bus master, fast devsel, latency 0

ff:02.3 Host bridge: Intel Corporation Core Processor Reserved (rev 05)
	Subsystem: Intel Corporation Device 8086
	Flags: bus master, fast devsel, latency 0
Comment 12 Benjamin Hardill 2012-07-05 19:20:44 EDT
I'm seeing something very similar with the BCM4313 in my new Lenovo U410.

NetworkManager is only shows only a few of the available networks if any, most attempts to assoiate timeout.

If a connection does complete then it will be very very slow before dropping.

This is all using the 3.4.4-3 x86_64 kernel using the included brcmsmac driver.

I saw mention of the 3.3.2-8 kernel here, but I've not been able to find it in the repos to give it a try. Can anybody point me at some where I can grab a copy for a test.

Also please let me know if you need me any logs or more details capturing as this is the last thing holding me back using my sweet new machine.

Ben
Comment 13 Justin M. Forbes 2012-12-07 11:47:45 EST
Is this still an issue with the 3.6.9 kernels?
Comment 14 Ankur Sinha (FranciscoD) 2013-01-06 14:59:10 EST
I'm sorry I couldn't reply to the needinfo. I've been on vacation the last month. Any way, I think it's been fixed since I do get good download speeds now, unlike when I reported the bug. Thanks! I'll file more bugs if I run into other issues.

Apologies,
Thanks,
Warm regards,
Ankur
Comment 15 Ankur Sinha (FranciscoD) 2013-01-06 14:59:41 EST
Oh, I'm now on:

Linux dhcppc1 3.6.11-3.fc18.x86_64 #1 SMP Mon Dec 17 21:35:39 UTC 2012 x86_64 x86_64 x86_64 GNU/Linux

Note You need to log in before you can comment on or make changes to this bug.